---
title: Reflect.apply()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/apply
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Reflect.apply()</code></strong> method calls a target function with arguments as specified.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-apply.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.apply(<var>target</var>, <var>thisArgument</var>, <var>argumentsList</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target function to call.</dd>
 <dt><code><var>thisArgument</var></code></dt>
 <dd>The value of <code>this</code> provided for the call to <code><var>target</var></code>.</dd>
 <dt><code><var>argumentsList</var></code></dt>
 <dd>An array-like object specifying the arguments with which <code><var>target</var></code> should be called.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The result of calling the given <code><var>target</var></code> function with the specified <code>this</code> value and arguments.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if the <code><var>target</var></code> is not callable.</p>

<h2 id="Description">Description</h2>

<p>In ES5, you typically use the {{jsxref("Function.prototype.apply()")}} method to call a function with a given <code>this</code> value and <code>arguments</code> provided as an array (or an <a href="/en-US/docs/Web/JavaScript/Guide/Indexed_collections#Working_with_array-like_objects">array-like object</a>).</p>

<pre class="brush: js notranslate">Function.prototype.apply.call(Math.floor, undefined, [1.75]);</pre>

<p>With <code>Reflect.apply()</code> this becomes less verbose and easier to understand.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.apply">Using Reflect.apply()</h3>

<pre class="brush: js notranslate">Reflect.apply(Math.floor, undefined, [1.75]);
// 1;

Reflect.apply(String.fromCharCode, undefined, [104, 101, 108, 108, 111])
// "hello"

Reflect.apply(RegExp.prototype.exec, /ab/, ['confabulation']).index
// 4

Reflect.apply(''.charAt, 'ponies', [3])
// "i"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.apply', 'Reflect.apply')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.apply")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li>{{jsxref("Function.prototype.apply()")}}</li>
</ul>
